(function() {

  tinymce.create('tinymce.plugins.travelduck', {
    init : function(ed, url) {

      ed.addCommand('travelduck_widgets', function() {
        ed.windowManager.open({
          id       : "travelduck-widgets",
          title    : "Insert TravelDuck Widget",
          width    : 400,
          height   : 250,
          body     : [],
          onsubmit : function(e) {
            submitEvent(ed, e);
          }
        }, {
          plugin_url : url
        });
        constructWindow();
      });

      ed.addButton('travelduck', {
        title : 'Insert TravelDuck Widget',
        cmd   : 'travelduck_widgets',
        image : url + '/../img/logo-icon.png'
      });

    }
  });
  tinymce.PluginManager.add('travelduck', tinymce.plugins.travelduck);





  function constructWindow() {
    var travelduckWidgetsBody = document.getElementById("travelduck-widgets-body");
    var body = jQuery(travelduckWidgetsBody).find(".mce-container-body");

    var form = jQuery('\
    <div style="padding: 0 15px">\
      <table class="form-table" style="width: 100%">\
        <tr>\
          <td style="width:139px"><label for="travelduck-widget-type-select">Widget to insert</label></td>\
          <td>\
            <select id="travelduck-widget-type-select">\
              <option value="travelduck-onlinebooking">Online Booking</option>\
              <option value="travelduck-availability">Availability Calendar</option>\
            </select>\
          </td>\
        </tr>\
        <tr>\
          <td><label for="travelduck-property-id">Property Id</label></td>\
          <td>\
            <input id="travelduck-property-id" type="number" min="1" style="padding: 5px" />\
          </td>\
        </tr>\
      </table>\
      <div id="online-booking-widget-wrapper">\
      \
      </div>\
      <div id="availability-widget-wrapper" style="display:none">\
        <table class="form-table" style="width: 100%">\
          <tr>\
            <td style="width:139px"><label for="travelduck-number-of-months">Number of Months</label></td>\
            <td>\
              <input id="travelduck-number-of-months" type="number" value="6" min="1" max="24" style="padding: 5px" />\
            </td>\
          </tr>\
          <tr>\
            <td><label for="travelduck-week-change-over-day">Change over day</label></td>\
            <td>\
              <select id="travelduck-week-change-over-day">\
                <option value="1">Monday</option>\
                <option value="2">Tuesday</option>\
                <option value="3">Wednesday</option>\
                <option value="4">Thursday</option>\
                <option value="5">Friday</option>\
                <option value="6">Saturday</option>\
                <option value="7">Sunday</option>\
              </select>\
            </td>\
          </tr>\
        </table>\
      </div>\
		</div>\
		');

    body.append(form);


    var syncDisplay = function() {
      if(jQuery(this).val() == "travelduck-onlinebooking") {
        jQuery("#availability-widget-wrapper").slideUp();
      } else {
        jQuery("#availability-widget-wrapper").slideDown();
      }
    };


    jQuery("#travelduck-widget-type-select").change(syncDisplay);


  }




  function submitEvent(editor, e) {
    var currentWidget = jQuery("#travelduck-widget-type-select").val();
    var propertyId = jQuery("#travelduck-property-id").val();

    if(!propertyId) {
      jQuery("#travelduck-property-id").css({
        border: "1px solid #f00"
      });
      e.stopImmediatePropagation();
      return false;
    }


    //
    // Generate ShortCode
    //
    var shortCode = '[' + currentWidget;
    switch(currentWidget) {

      //
      // Online Booking ShortCode
      //
      case 'travelduck-onlinebooking':
        shortCode += ' property-id="' + propertyId + '"';
        break;

      //
      // Availability Calendar ShortCode
      //
      case 'travelduck-availability':
        shortCode += ' property-id="' + propertyId + '"';

        var numberOfMonths = jQuery("#travelduck-number-of-months").val();
        shortCode += ' number-of-months-to-display="' + numberOfMonths + '"';

        var changeOverDay = jQuery("#travelduck-week-change-over-day").val();
        shortCode += ' week-change-over-day="' + changeOverDay + '"';

        break;

      //
      // Error
      //
      default:
        console.error('Unknown TravelDuck Widget Type: ' + currentWidget);
        return;
    }
    shortCode += ']';


    //
    // Inject Generated ShortCode into Editor
    //
    editor.insertContent(shortCode);
  }




})();